var jQT = new $.jQTouch({
    //icon: 'icon.png',
    //startupScreen: 'img/startup.png',
    slideSelector: '.slide',
    preloadImages: [
                    'jqtouch/themes/apple/img/grayButton.png',
                    'img/toolButton.png',
                    'jqtouch/themes/apple/img/chevron.png',
                    'img/on_off.png',
                    'img/on_off_loading.png',
                    'img/toolbar.png'
                    ]
});


$(function(){		
	loadSensors();
	loadPowersockets();
	loadTriggers();
});

$(document).ready(function(e){
    $('#powersocket').bind('pageAnimationStart', function(event, info){
        //console.log($(this).data('referrer').html());
        loadPowersocket($(this).data('referrer').html());
    });
    $('#sensor').bind('pageAnimationStart', function(event, info){
        //console.log($(this).data('referrer').html());
        loadSensor($(this).data('referrer').html());
    });
    $('#trigger').bind('pageAnimationStart', function(event, info){
        //console.log($(this).data('referrer').html());
        loadTrigger($(this).data('referrer').html());
    });
    
    $('#reloadTrigger').bind('tap', function(event, info){
        loadTrigger($('#triggertitle').html());
    });
    $('#reloadTrigger').bind('click', $(this).tap);
    
    $('#reloadSensor').bind('tap', function(event, info){
        loadSensor($('#sensortitle').html());
    });
    $('#reloadSensor').bind('click', $(this).tap);
    
    $('#reloadPowersocket').bind('tap', function(event, info){
        loadPowersocket($('#powersocketid').html());
    });
    $('#reloadPowersocket').bind('click', $(this).tap);
    
});

/*
 * Set the Loading indicator to given state (bool)
 *   and optional additional the given element too
 */
function isLoading(bool, refId) {
	if (bool) {
		$('#loadIndicator').addClass('isLoading');
		$(refId).addClass('isLoading');
	} else {
		$('#loadIndicator').removeClass('isLoading');
		$(refId).removeClass('isLoading');
	}
	
	console.log('isLoading: ' + bool);
}

function ajax_switchSocket(powerid, socketid, oldstate, refToggle) {
	if ($(refToggle).hasClass('isLoading')) {
		console.log('socket '+socketid+' is loading. Wait!');
		return false;
	} else {
		isLoading(true, refToggle);
		var wasChecked;
		if (refToggle.checked) 
			wasChecked = 0;
		else
			wasChecked = 1;
		console.log("wasChecked? "+wasChecked);
		var callbackstr = "callback_switchSocket('"+powerid+"', "+socketid+", "+wasChecked+")";
		setTimeout(callbackstr, 2000);
		return true;
	}
}

function callback_switchSocket(powerid, socketid, oldstate) {
	var ref = "#switch"+socketid;
	var onstr = "[]";
	var offstr = "[]";
	
	if (oldstate == 1)
		//var actionstr = "off=" + socketid;
		offstr = "["+socketid+"]";
	else if (oldstate == 0)
		//var actionstr = "on=" + socketid;
		onstr = "["+socketid+"]";
	
	var actionstr = '{"id": "'+powerid+'", "action": "switch", "on": '+onstr+', "off": '+offstr+'}';
	
	var res = $.ajax({
	      url: "powersocket/"+powerid+"/",
	      global: false,
	      type: "POST",
	      data: actionstr,
	      contentType: "application/json",
	      async:false
	   }
	).responseText;
	console.log(res);
	
	//remove isLoading
	isLoading(false, ref);
}

function loadPowersockets() {
	console.log('loadPowersockets!');
	$("#powersocketlist").html(""); //reset ul
	
	$.getJSON("powersocket/", function(data) {
		$.each(data, function(i) {
			//ontouch=\"alert('touched')\" ontap=\"alert('tapped')\" onclick=\"javascript:loadPowersocket('"+data[i]+"')\"
			$("#powersocketlist").append("<li class=\"forward\"><a href=\"#powersocket\"" +
					"class=\"slide\">"+data[i]+"</a></li>");
		});
	});
	//rebindClicks();
}

function loadSensors() {
	console.log('loadSensors!');
	$("#sensorlist").html("");
	
	$.getJSON("sensor/", function(data) {
		$.each(data, function(i){
			//onclick=\"javascript:loadSensor('"+data[i]+"')\"
			$("#sensorlist").append("<li class=\"forward\"><a href=\"#sensor\"" +
					"class=\"slide\">"+data[i]+"</a></li>");
		});
	});
}

function loadTriggers() {
	console.log('loadTriggers!');
	$("#triggerlist").html("");
	
	$.getJSON("trigger/", function(data) {
		$.each(data, function(i){
			//onclick=\"javascript:loadTrigger('"+data[i]+"')\"
			$("#triggerlist").append("<li class=\"forward\"><a href=\"#trigger\"" +
					"class=\"slide\">"+data[i]+"</a></li>");
		});
	});
}

function loadPowersocket(id) {	
	$.getJSON("powersocket/"+id+"/", function(data) {
		console.log(data);
		$('#powersocketid').html(data.id);
		$("#powersocketdetails").html('<li>IP<span class="right">'+data.ip+'</span></li>');
		
		if (data.states[0] == null && data.states[1] == null && data.states[2] == null && data.states[3] == null) {
			$("#powersocketdetails").append('<li class="red">Powersocket is unavailable.</li>');
		}
		var states = "";
		//States of Sockets
		for (var i = 0; i < 4; i++) {
			var x = (i+1);
			states += "<li>";
				states += '<span class="col1">'+ x +'</span>';
				states += '<span class="col2">';
				var checked = "";
				if (data.states[i] == 1) {
					checked = "checked=\"checked\"";
				}
				states += '</span>';
				states += '<span class="toggle">';
				if (data.states[i] != null)
					states += '<input type="checkbox" '+ checked +' id="switch'+x+'" class="onofftoggle"' +
						'onClick="return ajax_switchSocket(\''+data.id+'\', '+x+', '+ data.states[i] +', this);"/>';
			states += '</span>';
			states += "</li>";
			
		}
		$('#powersocketdetailsswitch').remove();
		$("#powersocketdetails").after('<ul id="powersocketdetailsswitch" class="rounded">'+
											'<li><span class="col1 bold">Socket</span> <span class="col2 bold">Action <span id="loadIndicator"></span></span></li>'+
											states +
										'</ul>');


	});
}

function loadSensor(id) {	
	var res = $.getJSON("sensor/"+id+"/", function(data) {
		$('#sensortitle').html(data.id);
		$("#sensordetails").html('<li>Value<span class="right">'+data.input+'</span></li>'+
								'<li>Type<span class="right">'+data.type+'</span></li>');
		$('#sensordetails2').html("");
		$('#sensordetails3').html("");
		if (data.comment == "null")
			data.comment = "no Comment";
		$("#sensordetails").after('<div id="sensordetails2"><ul class="rounded"><li>'+data.comment+'</li></div>');
		$("#sensordetails2").after('<div id="sensordetails3"><ul id="sensordetails3ul" class="rounded"><li class="bold">History</li>');
		for (var i = 0; i<data.history.length; i++) {
			$("#sensordetails3ul").append('<li>'+data.history[i].value+'<span class="right">'+data.history[i].date+'</span></li>');
		}
		$("#sensordetails3").append('</ul></div>');
	});
	console.log(res);
}

function loadTrigger(id) {	
	var res = $.getJSON("trigger/"+id+"/", function(data) {
		$('#triggertitle').html(data.id);
		$("#triggerdetails").html('<li>Sensor<span class="right">'+data.sensorid+'</span></li>'+
								'<li>Aktor<span class="right">'+data.aktorid+'</span></li>'+
								'<li>Limit<span class="right">'+data.limit+'</span></li>'+
								'<li>Direction<span class="right">'+data.direction+'</span></li>');
		$('#triggerdetails2').html("");
		$("#triggerdetails").after('<div id="triggerdetails2"><h2>Description</h2><ul class="rounded">'+
				'<li>'+data.description+'</li>'+
			'</ul></div>');
	});
	console.log(res);
}

function log(s) {
	console.log(s);
}

function editPowersocket() {
	if (($('#powerid').val() == "") || ($('#powerip').val() == "") 
			|| ($('#powerpassword').val() == "")) {
		$('#errorpowerform').html('<ul class="rounded"><li style="background-color: #FFE4E1;">ID, IP and Password are obligatory.</li></ul>');
	} else {
		var powersocket = new Object;
		powersocket.id = $('#powerid').val();
		powersocket.ip = $('#powerip').val();
		powersocket.password = $('#powerpassword').val();
		
		if ($('#powercomment') != null)
			powersocket.comment = $('#powercomment').val();
		
		$.ajax({
			  url: "powersocket/"+powersocket.id+"/",
			  type: 'POST',
			  dataType: 'application/json',
			  contentType: 'application/json',
			  data: JSON.stringify(powersocket),
			  success: function(data) {
				  if (data.indexOf("success") >= 0) {
					  $('#errorpowerform').html('<ul class="rounded"><li style="background-color: lightgreen;">Saved.</li></ul>');
				  }
				  loadPowersockets();
			  }
		});
	}
}

function editTrigger() {
	if (($('#triggerid').val() == "") || ($('#triggeraktorid').val() == "") 
			|| ($('#triggersensorid').val() == "") || ($('#triggerlimit').val() == "") || ($('#triggerdirection').val() == "")  || ($('#triggeractionstring').val() == "")) {
		$('#statustrigger').html('<ul class="rounded"><li style="background-color: #FFE4E1;">ID, Akotor ID, Sensor ID, Direction and Aktor Commands are obligatory!</li></ul>');
	} else {
		var trigger = new Object;
		trigger.id = $('#triggerid').val();
		trigger.aktorid = $('#triggeraktorid').val();
		trigger.sensorid = $('#triggersensorid').val();
		trigger.limit = $('#triggerlimit').val();
		trigger.direction = $('#triggerdirection').val();
		trigger.actionstring = eval($('#triggeractionstring').val());
		
		if ($('#triggercomment') != null)
			trigger.description = $('#triggercomment').val();
		
		$.ajax({
			  url: "trigger/"+trigger.id+"/",
			  type: 'POST',
			  dataType: 'application/json',
			  contentType: 'application/json',
			  data: JSON.stringify(trigger),
			  success: function(data) {
				  if (data.indexOf("success") >= 0) {
					  $('#statustrigger').html('<ul class="rounded"><li style="background-color: lightgreen;">Saved.</li></ul>');
				  } else {
					  $('#statustrigger').html('<ul class="rounded"><li style="background-color: lightgreen;">Creation failed with unknown error. Sorry.</li></ul>');
				  }
				  loadTriggers();
			  }
		});
	}
}

function editSensor() {
	if ($('#sensorid').val() == "") {
		log("empty");
		$('#statussensor').html('<ul class="rounded"><li style="background-color: #FFE4E1;">ID is obligatory.</li></ul>');
	} else {
		log("not empty");
		var sensor = new Object;
		sensor.id = $('#sensorid').val();
		
		if ($('#sensorcomment') != null)
			sensor.comment = $('#sensorcomment').val();
		if ($('#sensorlocation') != null)
			sensor.location = $('#sensorlocation').val();
		if ($('#sensortype') != null)
			sensor.type = $('#sensortype').val();
		
		$.ajax({
			  url: "sensor/"+sensor.id+"/",
			  type: 'POST',
			  dataType: 'application/json',
			  contentType: 'application/json',
			  data: JSON.stringify(sensor),
			  success: function(data) {
				  if (data.indexOf("success") >= 0) {
					  $('#statussensor').html('<ul class="rounded"><li style="background-color: lightgreen;">New Sensor Saved.</li></ul>');
				  }
				  loadSensors();
			  }
		});
	}
}

function rebindClicks(){
    var userAgent = navigator.userAgent.toLowerCase();
    var isIphone = (userAgent.indexOf('iphone') != -1) ? true : false;
 
    if (isIphone) {
        // For each event with an inline onclick
        $('[onclick]').each(function() {
            var onclick = $(this).attr('onclick');
            $(this).removeAttr('onclick'); // Remove the onclick attribute
            $(this).bind("click", preventClickEvent); // See to it that clicks never happen
            $(this).bind('tap', onclick); // Point taps to the onclick
        });
    }
}
 
function preventClickEvent(event)  {
    event.preventDefault();
}
