/*
 * Important Fact: Restlet do not reply with Response if no Host: after GET String 
 */

#include <SPI.h>
#include <Ethernet.h>
#include <String.h>
#include <NewSoftSerial.h> //Using (Normal) SoftwareSerial with .read(). Programm will stop until Data will come!!
#include <String.h>

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
byte ip[] = { 192,168,1,200 };
byte server[] = { 192,168,1,100 };
Client client(server, 8080);

//CONFIG
unsigned long LAST_ROUND = 0;
int ROUND_INTERVALL = 10000;
int ROUND = 0;

/* VARS **/
//Temp
#define TEMP     2
String temperature;

//Light
#define PHOTOCELL     0  // the cell and 10K pulldown are connected to a0
int lightness;     // the analog reading from the sensor divider
int DARK = 150;
int FAIRLIGHT = 550;
int BRIGHT = 900;

//RFID
NewSoftSerial rfid =  NewSoftSerial(7,-1);

void setupTemp();

void setup() {
  // start the serial library:
  Serial.begin(9600);
  
  setupTemp();
  setupRFID();
  
  // give everyhting some time to initialize:
  delay(1000);
  Serial.println("=== Brainbox-duino ===");
  Serial.println("will do sth in 10s");
}

void loop() {
  rfid_read();
  
  if (millis() - LAST_ROUND > ROUND_INTERVALL) {
    
    if (ROUND == 0) {
        handleTemp();
        send2brainbox("temp", temperature);
        ROUND++;
    } else {
        handleLight();
        send2brainbox("light", lightness);
        ROUND--;
    }
    
    LAST_ROUND = millis();
  } else {
  
  }
}
