
void OneWireReset(int Pin);//See Note 2
void OneWireOutByte(int Pin, byte d);
byte OneWireInByte(int Pin);

void setupTemp() {
  digitalWrite(TEMP, LOW); //Temperature
  //pinMode(TEMP, INPUT);      // sets the digital pin as input (logic 1)

}

void handleTemp() {
  int HighByte, LowByte, TReading, SignBit, Tc_100, Whole, Fract;
  String temperStr;
  
  //Temp start
    OneWireReset(TEMP);
    OneWireOutByte(TEMP, 0xcc);
    OneWireOutByte(TEMP, 0x44); // perform temperature conversion, strong pullup for one sec
  
    OneWireReset(TEMP);
    OneWireOutByte(TEMP, 0xcc);
    OneWireOutByte(TEMP, 0xbe);
  
    LowByte = OneWireInByte(TEMP);
    HighByte = OneWireInByte(TEMP);
    TReading = (HighByte << 8) + LowByte;
    SignBit = TReading & 0x8000;  // test most sig bit
    if (SignBit) // negative
    {
      TReading = (TReading ^ 0xffff) + 1; // 2's comp
    }
    Tc_100 = (6 * TReading) + TReading / 4;    // multiply by (100 * 0.0625) or 6.25
  
    Whole = Tc_100 / 100;  // separate off the whole and fractional portions
    Fract = Tc_100 % 100;
  
    temperStr = "";
    if (SignBit) // If its negative
    {
       temperStr = temperStr + "-";
    }
    temperStr = temperStr + Whole + ".";
    if (Fract < 10)
    {
       temperStr + temperStr + "0";
    }
  
    temperStr = temperStr + Fract;
    temperature = temperStr;
}

/* HELPER */
void OneWireReset(int Pin) // reset.  Should improve to act as a presence pulse
{
     digitalWrite(Pin, LOW);
     pinMode(Pin, OUTPUT); // bring low for 500 us
     delayMicroseconds(500);
     pinMode(Pin, INPUT);
     delayMicroseconds(500);
}

void OneWireOutByte(int Pin, byte d) // output byte d (least sig bit first).
{
   byte n;

   for(n=8; n!=0; n--)
   {
      if ((d & 0x01) == 1)  // test least sig bit
      {
         digitalWrite(Pin, LOW);
         pinMode(Pin, OUTPUT);
         delayMicroseconds(5);
         pinMode(Pin, INPUT);
         delayMicroseconds(60);
      }
      else
      {
         digitalWrite(Pin, LOW);
         pinMode(Pin, OUTPUT);
         delayMicroseconds(60);
         pinMode(Pin, INPUT);
      }

      d=d>>1; // now the next bit is in the least sig bit position.
   }

}

byte OneWireInByte(int Pin) // read byte, least sig byte first
{
    byte d, n, b;

    for (n=0; n<8; n++)
    {
        digitalWrite(Pin, LOW);
        pinMode(Pin, OUTPUT);
        delayMicroseconds(5);
        pinMode(Pin, INPUT);
        delayMicroseconds(5);
        b = digitalRead(Pin);
        delayMicroseconds(50);
        d = (d >> 1) | (b<<7); // shift d to right and insert b in most sig bit position
    }
    return(d);
}
