package edu.dhbw.brainbox;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.dhbw.inputs.BaseInput;
import edu.dhbw.triggers.BaseTrigger;


public class TriggerRegistry {
	private Map<BaseInput, List<BaseTrigger>> registry;
	private String id;
	
	public TriggerRegistry(String id) {
		registry = new HashMap<BaseInput, List<BaseTrigger>>();
		this.id = id;
	}
	
	public String getId() {
		return this.id;
	}
	
	public void registerTrigger(BaseTrigger trigger) {
		//For Sensor
		BaseInput ofsensor = trigger.getSensor();
		//Sensor enthalten
		if (registry.containsKey(ofsensor)) {
			//Trigger of sensor
			List<BaseTrigger> triggersof = registry.get(ofsensor);
			
			//new TriggerList if null
			if (triggersof == null) {
				triggersof = new ArrayList<BaseTrigger>();
			}
			//Add Trigger to List
			triggersof.add(trigger);
			
			//Replace triggerlist
			registry.put(ofsensor, triggersof);
			
		} else {
			List<BaseTrigger> triggersof = new ArrayList<BaseTrigger>();
			triggersof.add(trigger);
			//insert triggerlist
			registry.put(ofsensor, triggersof);
		}
		
	}
	
	public void checkForEvent(BaseInput sensor) {
		List<BaseTrigger> triggers = registry.get(sensor);
		if (triggers != null) {
			//Triggers exists
			for (BaseTrigger baseTrigger : triggers) {
				Double value = Double.parseDouble(sensor.getInput());
				Boolean isEvent = baseTrigger.shouldFire(value);
				if (isEvent) {
					baseTrigger.fireAction();
				}
			}
		}
		
	}
}
