package edu.dhbw.brainbox.outputs;

import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.conn.params.ConnRoutePNames;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

public class AktorBoxcarAPI extends AktorHTTP {
	
	private String account = "b62faa59b773d05bdad059dc2ededb7c";
	private String appname = "Brainbox";
	public void setAppname(String appname) {this.appname = appname;}
	public void setAccount(String account) {this.account = account;}
	public String getAppname() {return appname;}
	public String getAccount() {return account;}

	public AktorBoxcarAPI(String id, String data) {
		super(id, "http://boxcar.io/devices/providers/D0orhkKjJiL5gEt4mQRz/notifications", data);
	}
	
	//Functional
	public Boolean send() {
		return send(getData());
	}
	
	private Boolean send(String data) {
		DefaultHttpClient httpclient = new DefaultHttpClient();
		HttpParams params = httpclient.getParams();
		HttpConnectionParams.setConnectionTimeout(params, 5000);
		HttpConnectionParams.setSoTimeout(params, 10000);
		
		if (this.proxy && this.proxyhost != null && this.proxyport != null) {
			HttpHost proxy = new HttpHost(proxyhost, proxyport);
			httpclient.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, proxy);
		}
		
		try {
		    // Send data
		    HttpPost http = new HttpPost(getUrl());
		    
		    //POST with login
		    List <NameValuePair> nvps = new ArrayList <NameValuePair>();
            nvps.add(new BasicNameValuePair("email", this.account));
            nvps.add(new BasicNameValuePair("notification[from_screen_name]", this.appname));
            nvps.add(new BasicNameValuePair("notification[message]", data));
            http.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));

            HttpResponse response = httpclient.execute(http);
            HttpEntity entity = response.getEntity();

            if (response.getStatusLine().getStatusCode() != HttpStatus.SC_OK) {
            	throw new HttpException();
            }

            //Check if login response content contains socket states
            if (entity != null) {
            	String returnstr =  EntityUtils.toString(entity);
            	//TODO: check http status code
            	if (returnstr != null) {
            		System.out.println("SUCCESS: "+this.toString());
            		return true;
            	}
            	else {
            		System.out.println("FAILURE: "+this.toString());
            		return false;
            	}
            }
            EntityUtils.consume(entity);
           
		} catch (Exception e) {
			System.out.println("Exception while sending HTTP POST to Boxcar API");
			System.err.println(e.getMessage());
			e.printStackTrace();
		} finally {
			httpclient.getConnectionManager().shutdown();
		}
		
		return false;
	}
	
	public Boolean fireAction(List<String> actions) {
		if (actions.size() == 1) {
			try {
				send(actions.get(0));
				return true;
			} catch (Exception e) {
				System.err.println("Parse Error to switch Socket in ActionString: "+e.getLocalizedMessage());
				e.printStackTrace();
				return false;
			}
		} else {
			System.err.println("Invalid ActionString to fire Action. Should length = 1.");
			return false;
		}
	}
	
	public String toString() {
		String message = getData();
		if (message.length() > 25)
			message = message.substring(0, 25).concat("...");
		return "AktorBoxcarAPI #"+getId()+" data: " + message;
	}
	
	public String toJSON() {
		StringBuilder sb = new StringBuilder();
        sb.append("{\n");
        sb.append("\"id\": \"" + getId() + "\",\n");
        sb.append("\"data\": \""+ getData() + "\",\n");
        sb.append("}");
        return sb.toString();
	}

}
