package edu.dhbw.brainbox.outputs;

import java.util.List;
import java.util.Properties;

import javax.mail.Authenticator;
import javax.mail.Message;
import javax.mail.Message.RecipientType;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.AddressException;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

import edu.dhbw.brainbox.MailAuth;

public class AktorMail extends BaseAktor {
	private String mail;
	private String subject;
	private String body;

	//Standard Getters & Setters	
	public String getMail() {
		return mail;
	}

	public void setMail(String mail) {
		this.mail = mail;
	}

	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}

	public String getBody() {
		return body;
	}

	public void setBody(String body) {
		this.body = body;
	}
	
	//Working Constructor
	public AktorMail(String id, String mail, String subject, String body) {
		super(id);
		this.mail = mail;
		this.subject = subject;
		this.body = body;
	}

	//Functional
	public Boolean sendMail() {
		return sendMail(this.mail, this.subject, this.body);
	}
	
	private Boolean sendMail(String mail, String subject, String body) {
		Properties props = new Properties();
		props.put("mail.smtp.host", "mail.gmx.net");
		props.put("mail.smtp.port", "587");
		props.put("mail.from", "stranged@gmx.net");
		props.put("mail.smtp.auth", "true");
		props.put("mail.smtp.user", "stranged@gmx.net");
		props.put("mail.smtp.password", "itisstrange");
		Authenticator acc = new MailAuth(props.getProperty("mail.smtp.user"), props.getProperty("mail.smtp.password"));
		
		Session mailSession = Session.getDefaultInstance(props, acc);
		Message simpleMessage = new MimeMessage(mailSession);
		
		InternetAddress fromAddress = null;
		InternetAddress toAddress = null;
		try {
			fromAddress = new InternetAddress(props.getProperty("mail.from"));
			toAddress = new InternetAddress(mail);
		} catch (AddressException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		try {
			simpleMessage.setFrom(fromAddress);
			simpleMessage.setRecipient(RecipientType.TO, toAddress);
			simpleMessage.setSubject(subject);
			simpleMessage.setText(body);
			
			Transport.send(simpleMessage);	
		} catch (MessagingException e) {
			// TODO Auto-generated catch block
			//e.printStackTrace();
			System.out.println(this.toString());
		}
		return true;
	}
	
	public Boolean fireAction(List<String> actions) {
		if (actions.size() == 3) {
			try {
				sendMail(actions.get(0),actions.get(1),actions.get(2));
				return true;
			} catch (Exception e) {
				System.err.println("Parse Error to switch Socket in ActionString: "+e.getLocalizedMessage());
				e.printStackTrace();
				return false;
			}
		} else {
			System.err.println("Invalid ActionString to fire Action. Should length = 2.");
			return false;
		}
	}
	
	public String toString() {
		return "AktorMail: to: '" + this.mail + "', subject: " + this.subject;
	}
	
	public String toJSON() {
		StringBuilder sb = new StringBuilder();
        sb.append("{\n");
        sb.append("\"mail\": \"" + this.mail + "\",\n");
        sb.append("\"subject\": \""+ this.subject + "\",\n");
        sb.append("\"body\": \""+ this.body + "\",\n");
        sb.append("}");
        return sb.toString();
	}
	
}
