package edu.dhbw.resources;
import org.restlet.data.Form;
import org.restlet.data.MediaType;
import org.restlet.data.Status;
import org.restlet.representation.Representation;
import org.restlet.representation.StringRepresentation;
import org.restlet.resource.Get;
import org.restlet.resource.Post;
import org.restlet.resource.ResourceException;

import edu.dhbw.brainbox.BrainApplication;
import edu.dhbw.brainbox.outputs.Powersocket;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class FormConfigPowersocket extends BrainBaseResource {

	/** 
     * Handle GET requests: Print out the StringRepresentation of Item (Powersocket)
     */  
	@Get
    public Representation printForm(Representation entity) throws ResourceException {
        Representation result = null;
        
        final StringBuilder sb = new StringBuilder();
        // Creates a text representation
        sb.append("<html>\n");
        sb.append("<body>\n");
        sb.append("<form method=\"post\"><br/>\n");
        sb.append("Powerid: <input name=\"power_id\" type=\"text\"/><br/>\n");
        sb.append("IP: <input name=\"power_ip\" type=\"text\"/><br/>\n");
        sb.append("Password: <input name=\"power_pw\" type=\"password\"/><br/>\n");
        sb.append("Comment: <textarea name=\"power_comment\" cols=\"140\" rows=\"5\"></textarea><br/>\n");
        sb.append("<input type=\"submit\"/>\n");
        sb.append("</form>\n");
        sb.append("</html>");
        result = new StringRepresentation(sb, MediaType.TEXT_HTML);

        return result;
    }
	
	/*
	 * Process POST to Insert new Powersocket Object by POST Variables
	 */
	@Post
	public Representation insertPowersocket(Representation entity) throws ResourceException {
		 Representation result = null;
		 
		 System.out.println("POST NEW POWERSOCKET");
		 
		//Get POST Vars
        Form form = new Form(entity);  
		String powerid = form.getFirstValue("power_id");
		String powerip = form.getFirstValue("power_ip");
		String powerpw = form.getFirstValue("power_pw");
		String powercomment = form.getFirstValue("power_comment");
        
		//return Failure if ID, IP, PW = null
		if (powerid == null
				&& powerip == null
				&& powerpw == null) {
			setStatus(Status.CLIENT_ERROR_BAD_REQUEST);
            Representation repFail = new StringRepresentation(
            		"Failure. ID, IP and Password are required!", 
                    MediaType.TEXT_PLAIN
            );  
            result = repFail;
		} else {
			Powersocket newPowersocket = new Powersocket(powerid, powerip, powerpw);
			if (powercomment != null) 
				newPowersocket.setComment(powercomment);
			
			//TODO: Check if Powersocket by ID already exists!
			
			//Put into DB
			((BrainApplication) getApplication()).putPowersocket(newPowersocket);
			
			// Set the response's status and entity  
            setStatus(Status.SUCCESS_CREATED);  
            Representation repCreated = new StringRepresentation(
            		"OK: "+powerid, 
                    MediaType.TEXT_PLAIN
            );  
            
            // Indicates the location of created resource (URI)
            repCreated.setLocationRef(getRequest().getResourceRef().getIdentifier()); 
            result = repCreated;	
		}
		 
		 return result;
	}
}
