package edu.dhbw.triggers;
import java.util.List;

import edu.dhbw.brainbox.outputs.BaseAktor;
import edu.dhbw.inputs.BaseInput;

public class BaseTrigger {
	
	private String id;
	private BaseInput sensor;
	private BaseAktor aktor;
	private String description;
	private List<String> actionstring;
	
	//Standard Getter & Setter
	public String getId() {
		return id;
	}
	public BaseInput getSensor() {
		return sensor;
	}

	public void setSensor(BaseInput sensor) {
		this.sensor = sensor;
	}

	public BaseAktor getAktor() {
		return aktor;
	}

	public void setAktor(BaseAktor aktor) {
		this.aktor = aktor;
	}

	public void setId(String automationid) {
		this.id = automationid;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
	
	public List<String> getActionstring() {
		return actionstring;
	}

	public void setActionstring(List<String> actionstring) {
		this.actionstring = actionstring;
	}

	//Working Constructor
	public BaseTrigger(String id) {
		super();
		this.id = id;
	}
	
	public Boolean shouldFire(Double value) {
		return false;
	};

	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("BaseTrigger: ");
		return sb.toString();
	}
	
	public String toJSON() {
		StringBuilder sb = new StringBuilder();
		sb.append("{\"id\": \""+this.getId()+"\", ");
		sb.append("\"description\": \""+this.getDescription()+"\", ");
		sb.append("\"actionstring\": \""+this.getActionstring()+"\"");
		sb.append("}");
		return sb.toString();
	}
	
	public Boolean fireAction() {return false;};
	
}
