package edu.dhbw.triggers;
import org.json.JSONArray;

import edu.dhbw.brainbox.outputs.BaseAktor;
import edu.dhbw.inputs.BaseInput;

public class TriggerEvent extends BaseTrigger {
	
	private Double flapping;
	private Double limit;
	private Integer direction;
	
	//Standard Getter & Setter

	public Double getFlapping() {
		return flapping;
	}

	public void setFlapping(Double flapping) {
		this.flapping = flapping;
	}

	public Double getLimit() {
		return limit;
	}

	public void setLimit(Double limit) {
		this.limit = limit;
	}

	public Integer getDirection() {
		return direction;
	}

	public void setDirection(Integer direction) {
		this.direction = direction;
	}

	//Working Constructor
	public TriggerEvent(String id, BaseInput sensor, BaseAktor aktor) {
		super(id);
		this.setSensor(sensor);
		this.setAktor(aktor);
	}
	
	public Boolean shouldFire(Double value) {
		if (direction > 0) {
			if (value > limit) {
				return true;
			} else
				return false;
		} else {
			if (value < limit) {
				return true;
			} else
				return false;
		}
	}
	
	public Boolean fireAction() {
		System.out.println("Should fire '"+getActionstring()+"' of Aktor #"+getAktor().getId());
		return getAktor().fireAction(getActionstring());
	}
	
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("TriggerEvent: ");
		if (getSensor() != null)
			sb.append("sensor: "+getSensor().getId()+"");
		if (getAktor() != null)
			sb.append("aktor: "+getAktor().getId()+"");
		if (getActionstring() != null)
			sb.append(getActionstring().toString());
		return sb.toString();
	}
	
	public String toJSON() {
		StringBuilder sb = new StringBuilder();
		sb.append("{\"id\": \""+this.getId()+"\", ");
		if (getSensor() != null)
			sb.append("\"sensorid\": \""+getSensor().getId()+"\", ");
		if (getAktor() != null)
			sb.append("\"aktorid\": \""+getAktor().getId()+"\", ");
		sb.append("\"limit\": \""+this.getLimit()+"\", ");
		sb.append("\"direction\": \""+this.getDirection()+"\", ");
		JSONArray actionstr = new JSONArray(getActionstring());
		sb.append("\"actionstring\": "+actionstr.toString()+",");
		sb.append("\"description\": \""+this.getDescription()+"\"");
		sb.append("}");
		return sb.toString();
	}
	
}
